#include "stdafx.h"

#include "Util.h"
#include "NpMsgrIPT.h"

#include <algorithm>
#include <sstream>

#include <time.h>
#include "GTCommonAPI.h"

#include "ConvertUTF.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNpMsgrIPT::CNpMsgrIPT()
{
	m_pNpSD = NULL;
}

CNpMsgrIPT::~CNpMsgrIPT()
{

}

////////////////////////////////////////////////////////////////////////////
// INpMsgrBuddy

void __stdcall CNpMsgrIPT::AdviseEvents(_INpMsgrIPTEvents * pEvents) // support multiple event receiver
{
	m_vecEvents.push_back( pEvents );
}

void __stdcall CNpMsgrIPT::UnadviseEvents(_INpMsgrIPTEvents * pEvents)
{
	vector<_INpMsgrIPTEvents*>::iterator it = find( m_vecEvents.begin(), m_vecEvents.end(), pEvents );
	if( it != m_vecEvents.end() )
		m_vecEvents.erase( it );

}

void __stdcall CNpMsgrIPT::InitModule(INpSessionDispatcher * pN5S_QM_MainServer)
{
	m_pNpSD = pN5S_QM_MainServer;

	//m_pNpSD->Register_INCOMING_REQUEST_PACKET_Handler( MSNG_CMD_IPTCLIENT, this );
}

int CNpMsgrIPT::SendQuery( USHORT usCMD, USHORT usBodyDataLen, LPCSTR szBodyData, int nCallerTrId )
{
	int nTrId = m_pNpSD->Send_REQUEST_PACKET( usCMD, usBodyDataLen, szBodyData, this );

	CIPTQueryItem * query = new CIPTQueryItem( nTrId, usCMD, szBodyData, usBodyDataLen, nCallerTrId );
	if (NULL != query) 
		m_listIPTQuery.push_back( query );

	return nTrId;
}

//class _INpSessionDispatcher_PacketHandler
void CALLBACK CNpMsgrIPT::INpSessionDispatcher_OnReceive_REQUEST_PACKET(INpSessionDispatcher * pEventSource, const INpPacket * pPacket)
{
//	F_TRACE("CNpMsgrIPT::INpSessionDispatcher_OnReceive_REQUEST_PACKET, cmd = 0x%04x\n", pPacket->M6V2()->usCMMD);

	// >>>  Ŷ ó CNpMsgrMain óѴ. m_vecEvents Լ ȣ κп   ߻.   ʿ.

	//CGBStream stream;
	//stream.UseExternalBuffer( pPacket->BodyData(), pPacket->BodyLength() );
	//
	//USHORT usCMMD = pPacket->M6V2()->usCMMD;
	//switch( usCMMD )
	//{
	//case MSNG_CMD_IPTCLIENT:
	//	{
	//		OutputDebugString(_T("~~~~~~~~~ REQUEST_PACKET: MSNG_CMD_IPTCLIENT ~~~~~~~~~\r\n"));

	//		uint16_t usIPTCMMD = stream.Read_U2();
	//		switch( usIPTCMMD )
	//		{
	//		case IPT_CMD_NOTIFYCALLINFO:
	//		case RESPONSE(IPT_CMD_NOTIFYCALLINFO):
	//			{
	//				//	suser_id_len	U1		߽ID  	
	//				//	suser_id		UTF-8	߽ID	
	//				//	suser_tel_len	U1		߽ ȭȣ  	
	//				//	suser_tel_num	UTF-8	߽ ȭȣ	
	//				//	cid_len			U1		CID  	Call ID: Session Unique 
	//				//	cid				UTF-8	CID	

	//				std::wstring strUserID;
	//				std::wstring strTelNo;
	//				std::wstring strCID;

	//				try
	//				{
	//					stream.Read_U8SS_to_Unicode_stl(strUserID);

	//					stream.Read_U8SS_to_Unicode_stl(strTelNo);

	//					stream.Read_U8SS_to_Unicode_stl(strCID);
	//				}
	//				catch( CGBStreamException e )
	//				{
	//					DLOG("[IN] CNpMsgrIPT::INpSessionDispatcher_OnReceive_REQUEST_PACKET\n\t"
	//						"PACKET body parse fail!!, e.Error()=%d, ipt cmmd=0x%04x", 
	//						e.Error(), usIPTCMMD );
	//					return;
	//				}

	//				//int nEventsSize = static_cast<int>(m_vecEvents.size());
	//				//for( int i=0 ; i <  nEventsSize; i++ )
	//				//	m_vecEvents[i]->NpMsgrIPT_OnNotifyCallInfo(strUserID, strTelNo, strCID);
	//			}
	//			break;
	//		case IPT_CMD_PHONECALL:
	//		case RESPONSE(IPT_CMD_PHONECALL):
	//			{
	//				//	res		U1		û 			0:  1: 
	//				//	cid_len	U1		CID  	Call ID: Session Unique 
	//				//	cid		UTF-8	CID	

	//				BYTE res = stream.Read_U1();

	//				std::wstring strCID;
	//				stream.Read_U8SS_to_Unicode_stl(strCID);
	//			}
	//			break;
	//		case IPT_CMD_HANGUP:
	//		case RESPONSE(IPT_CMD_HANGUP):
	//			{
	//				//	res	U1	û 	0: , 1: 

	//				BYTE ret = stream.Read_U1();
	//			}
	//			break;
	//		case IPT_CMD_SETCALLFORWARDING:
	//		case RESPONSE(IPT_CMD_SETCALLFORWARDING):
	//			{
	//				//	res	U1	û 	0: , 1: 

	//				BYTE ret = stream.Read_U1();
	//			}
	//			break;
	//		case IPT_CMD_GETCALLFORWARDINGINFO:
	//		case RESPONSE(IPT_CMD_GETCALLFORWARDINGINFO):
	//			{
	//				//	res		U1		û 	0: , 1: 
	//				//	id_len	U1		ID  	
	//				//	id		UTF-8	ID	
	//				//	act		U1		 	0:  , 1: 
	//				//	tel_len	U1		ȭȣ  	
	//				//	tel_num	UTF-8	ȭȣ	

	//				BYTE ret = stream.Read_U1();

	//				std::wstring strUserID;
	//				stream.Read_U8SS_to_Unicode_stl(strUserID);

	//				BYTE act = stream.Read_U1();

	//				std::wstring strTelNo;
	//				stream.Read_U8SS_to_Unicode_stl(strTelNo);
	//			}
	//			break;
	//		case IPT_CMD_SETHOTRANSFER:
	//		case RESPONSE(IPT_CMD_SETHOTRANSFER):
	//			{
	//				//	res	U1	û 	0: , 1: 

	//				BYTE ret = stream.Read_U1();
	//			}
	//			break;
	//		case IPT_CMD_PICKUP:
	//		case RESPONSE(IPT_CMD_PICKUP):
	//			{
	//				//	res	U1	û 	0: , 1: 

	//				BYTE ret = stream.Read_U1();
	//			}
	//			break;
	//		case IPT_CMD_SETDND:
	//		case RESPONSE(IPT_CMD_SETDND):
	//			{
	//				//	res	U1	û 	0: , 1: 

	//				BYTE ret = stream.Read_U1();
	//			}
	//			break;
	//		case IPT_CMD_GETPHONESTATUS:
	//		case RESPONSE(IPT_CMD_GETPHONESTATUS):
	//			{
	//				//	res	U1	û 	0: , 1: 

	//				BYTE ret = stream.Read_U1();
	//			}
	//			break;
	//		}
	//	}
	//	break;
	//default:
	//	OutputDebugString(_T("~~~~~~~~~ REQUEST_PACKET: UNKNOWN PACKET ~~~~~~~~~\r\n"));
	//	break;
	//}
}

void CALLBACK CNpMsgrIPT::INpSessionDispatcher_OnReceive_RESPONSE_PACKET(INpSessionDispatcher * pEventSource, const INpPacket * pOriginalRequestPacket, const INpPacket * pPacket)
{
	m_pNpSD->Deregister_RESPONSE_PACKET_Handler( pPacket->M6V2()->ulTrId );

	CIPTQueryItem* pQueryItem = NULL;
	list<CIPTQueryItem*>::iterator it = m_listIPTQuery.begin();
	for( ; it != m_listIPTQuery.end() ; it++ )
	{
		if( (*it)->m_nTrId == pPacket->M6V2()->ulTrId )
		{
			pQueryItem = *it;
			m_listIPTQuery.erase( it );
			break;
		}
	}

	if( !pQueryItem )
		return;

	USHORT usQueryResultCode = RC_UNDEFINED;
	string strServerMsg;
	
	CGBStream stream;
	stream.UseExternalBuffer( pPacket->BodyData(), pPacket->BodyLength() );

	USHORT usResponseCode = stream.Read_U2();
	int nCallerTrId = pQueryItem->m_nCallerTrId;

	CGBStream stream_send;
	stream_send.UseExternalBuffer( pQueryItem->m_pszSendData, pQueryItem->m_nSendDataLength );
	
	//switch( pQueryItem->m_usCMMD )
	//{
	//case MSNG_CMD_IPTCLIENT:
	//	{
	//		OutputDebugString(_T("~~~~~~~~~ RESPONSE_PACKET: MSNG_CMD_IPTCLIENT ~~~~~~~~~\r\n"));

	//	}
	//	break;
	//}
	
	delete pQueryItem;
}

void CALLBACK CNpMsgrIPT::IkWnd_OnMessage(CIkWnd * pIkWnd, UINT message, WPARAM wParam, LPARAM lParam )
{

}

///////////////////////////////////////////////////////////////////////////////
// IPT Command
///////////////////////////////////////////////////////////////////////////////

bool CNpMsgrIPT::PhoneCall(LPCWSTR strUserID, LPCWSTR strPhoneNo, int nTrid)
{
//	GT_FLOG(L"IPT::PhoneCall : [%s][%s]", strUserID, strPhoneNo);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x0402);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strPhoneNo));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::AnswerCall(LPCWSTR strUserID, LPCWSTR strCID, int nTrid)
{
//	GT_FLOG(L"IPT::AnswerCall : [%s][%s]", strUserID, strCID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x040C);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strCID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::HangUp(LPCWSTR strUserID, LPCWSTR strCID, int nTrid)
{
//	GT_FLOG(L"IPT::HangUp : [%s][%s]", strUserID, strCID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x0403);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strCID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::CallForwarding(LPCWSTR strUserID, BYTE nMode, LPCWSTR strPhoneNo, int nTrid)
{
//	GT_FLOG(L"IPT::CallForwarding : [%s][%d][%s]", strUserID, nMode, strPhoneNo);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x0404);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U1(nMode);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strPhoneNo));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::CallForwardingInfo(LPCWSTR strUserID, int nTrid)
{
//	GT_FLOG(L"IPT::CallForwardingInfo : [%s]", strUserID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x0405);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::CallTransfer(LPCWSTR strUserID, LPCWSTR strTargetID, int nTrid)
{
//	GT_FLOG(L"IPT::CallTransfer : [%s][%s]", strUserID, strTargetID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x0406);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strTargetID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::CallPickUp(LPCWSTR strUserID, LPCWSTR strTargetID, int nTrid)
{
//	GT_FLOG(L"IPT::CallPickUp : [%s][%s]", strUserID, strTargetID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x0408);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strTargetID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::SetDND( LPCWSTR strUserID, BYTE nMode, int nTrid)
{
//	GT_FLOG(L"IPT::SetDND : [%s][%d]", strUserID, nMode);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x0409);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U1(nMode);

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::PhoneStatus( LPCWSTR strUserID, vector<LPCWSTR> &vecUserID, int nTrid)
{
//	GT_FLOG(L"IPT::PhoneStatus : [%s][%d]", strUserID, vecUserID.size());

	CGBStream stream;
	stream.CreateStream(40960);

	try
	{
		stream.Write_U2(0x040A);

		stream.Write_U8SS((_t_UTF8)(strUserID));

		stream.Write_U1(vecUserID.size());
		vector<LPCWSTR>::const_iterator itr = vecUserID.begin();
		for(; itr != vecUserID.end(); itr++)
			stream.Write_U8SS((_t_UTF8)((LPCWSTR)*itr));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::ConferenceCall(LPCWSTR strUserID, LPCWSTR strPhoneNo, int nTrid)
{
//	GT_FLOG(L"IPT::ConferenceCall : [%s][%s]", strUserID, strPhoneNo);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x040B);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strPhoneNo));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::HoldCall(LPCWSTR strUserID, LPCWSTR strCID, int nTrid)
{
//	GT_FLOG(L"IPT::HoldCall : [%s][%s]", strUserID, strCID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x040D);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strCID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::ResumeCall(LPCWSTR strUserID, LPCWSTR strCID, int nTrid)
{
//	GT_FLOG(L"IPT::ResumeCall : [%s][%s]", strUserID, strCID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x040E);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strCID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}

bool CNpMsgrIPT::DndStatusInfo(LPCWSTR strUserID, int nTrid)
{
//	GT_FLOG(L"IPT::DndStatusInfo : [%s]", strUserID);

	CGBStream stream;
	stream.CreateStream();

	try
	{
		stream.Write_U2(0x040F);
		stream.Write_U8SS((_t_UTF8)((LPCWSTR)strUserID));

		SendQuery( static_cast<USHORT>(MSNG_CMD_IPTCLIENT), static_cast<USHORT>(stream.GetDataLen()), stream.GetData(), nTrid );
	}
	catch( CGBStreamException e )
	{
		;
	}

	return true;
}
